<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:msxsl="urn:schemas-microsoft-com:xslt"
      xmlns:trend="http://trendmicro.com/smex">
  <xsl:output method="html" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
  <xsl:variable name="localization"      select="document('localization.xml')/strings/group[@name='trendx_detail']//string"/>
  <xsl:variable name="virus_encyclopedia_link"		select="document('localization.xml')/strings/group[@name='log']/string[@name='virus_encyclopedia_link']"/>
  <xsl:variable name="AddFileSHA256_js_function"		select="document('localization.xml')/strings/group[@name='log']/string[@name='virus_detail_log_AddFileSHA256_js']"/>
  <xsl:variable name="AddFileSHA256_js_function_end"	select="document('localization.xml')/strings/group[@name='log']/string[@name='virus_detail_log_js_end']"/>
  <xsl:variable name="AddFileSHA256_btn_text"	select="document('localization.xml')/strings/group[@name='log']/string[@name='btn_text_AddFileSHA256']"/>
  <xsl:variable name="PageTitle"		select="document('localization.xml')/strings/group[@name='log']/string[@name='virus_detail_log_title']"/>
  <xsl:variable name="action_description_list" select="document('action_descriptions.xml')//action_description/action"/>
  <xsl:variable name="trendx_threat_type_list"	    select="document('trendx_threat_type_table.xml')//trendx_threat_type_description/type"/>
  <xsl:template match="/">
    <html>
      <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <link href="../css/trend-style-new.css" rel="stylesheet" type="text/css"/>
		<script language="JavaScript" src="../javascripts/trend-ui-new.js"></script>
		<script language="JavaScript" src="../javascripts/OLH_Mapping.js"></script>
		<script language="JavaScript" src="../javascripts/prototype.js"></script>
		<script language="JavaScript" src="../javascripts/localization.js"></script>
        <script language="JavaScript" type="text/JavaScript">
          <![CDATA[

          function jsAddFileSHA256(strFileSHA256)
          {
		  var url = "cgiDispatcher.exe";  
	      var PostArgument = "Page=scan/Virusscan_TrendX_Detail.htm&FileSHA256=" + strFileSHA256 + "&FormAction=AddFileSHA256&SessionCheck=0";
          AjaxGetServerBrief = createXMLHttpRequest();
	      AjaxGetServerBrief.open("POST", url, true);
          AjaxGetServerBrief.onreadystatechange = function(){
               if (AjaxGetServerBrief.readyState == 4) {
                   if (AjaxGetServerBrief.status == 200) {
                       jsGetServerInfoDone(AjaxGetServerBrief.responseText);
                    }
                }
            };
          AjaxGetServerBrief.send(PostArgument);            
          return;

          }
		  
		  function jsGetServerInfoDone(responseText)
		  {
			
			var response = responseText; 
			var error;
			var i = response.indexOf("FileHashNumMax:");
			if(i!=-1)
				error= response.substring(i+15,i+19);
			if(error=="true")
			{
				alert(STR_WARN_FILEHASHLIST);
			}
			
		  }

          ]]>
        </script>
          <title>
            <xsl:value-of select="$PageTitle"/>
          </title>
        <style>
          body 			{FONT-SIZE: 10px;COLOR: #000000;FONT-FAMILY: "Verdana", "Arial", "Helvetica", "sans-serif"; margin:0px; padding-top:0px;}
          a:link			{COLOR: #000000;TEXT-DECORATION: underline;}
          a:visited		{COLOR: #000000;TEXT-DECORATION: underline;}
          a:hover			{COLOR: #ff0000;TEXT-DECORATION: none;}
          img				{BORDER: 0px;VERTICAL-ALIGN: middle;}
          td				{FONT-SIZE: 10px;COLOR: #000000;}
          .content-title 	{FONT-WEIGHT: bold;FONT-SIZE: 13px;COLOR: #333333;}
          .tableheader	{BORDER-TOP: #ffffff 1px solid;BORDER-LEFT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;PADDING-LEFT: 5px;FONT-WEIGHT: bold;HEIGHT: 22px;COLOR: #5b593d;BACKGROUND-COLOR: #dddcc5;}
          .border			{BORDER: #666666 1px solid;}
          .grey			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-RIGHT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey-end		{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-BOTTOM: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey2			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-RIGHT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;BORDER-TOP: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey2-end		{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-BOTTOM: #999999 1px solid;BORDER-TOP: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .data1			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;HEIGHT: 18;BACKGROUND-COLOR: #ffffff;word-break:break-all;}
          .data1b			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;HEIGHT: 18;BACKGROUND-COLOR: #ffffff;BORDER-RIGHT: #cccccc 1px solid;}
          .data2			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;HEIGHT: 18;BACKGROUND-COLOR: #ececdb;}
          .data2b			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;HEIGHT: 18;BACKGROUND-COLOR: #ececdb;BORDER-RIGHT: #cccccc 1px solid;}
        </style>
      </head>

      <body>
        <div align="center">
          <a name="top-of-page"/>
          <xsl:call-template name="detail-banner"/>
          <table width="650" border="0" cellspacing="0" cellpadding="0"  align="center">
            <xsl:call-template name="detail-head"/>
			<tr><td height="30"></td></tr> <!--add a empty row -->
            <xsl:call-template name="detail-body"/>
            <xsl:call-template name="detail-foot"/>
          </table>
        </div>
      </body>
    </html>
  </xsl:template>

  <!--|| TEMPLATE : detail-banner || -->
  <xsl:template name="detail-banner">
    <table width="650" border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td height="44" width="650">
          <img src="../images/new_banner.gif" />
        </td>
      </tr>
    </table>
  </xsl:template>

  <!--|| TEMPLATE : detail-head ||-->
  <xsl:template name="detail-head">
    <a name="top-of-page"/>
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td class="content-title" height="25" style="word-break:break-word;">
              <xsl:value-of select="//record/@detection_name"/>
            </td>
            <td align="right">
              <div id="divToolbar"></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr>
      <td height="1" background="../images/dot.gif" style="background-position:center;background-repeat:repeat-x;"></td>
    </tr>
    <tr>
      <td height="10"></td>
    </tr>
    <!--||Table of Scan Info||-->
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
          <tr>
            <td class="tableheader" colspan="2">
              <xsl:value-of select="$localization[@name='trendx_scan_title']"/>
            </td>
          </tr>
          <tr>
            <td class="grey" width="30%">
              <xsl:value-of select="$localization[@name='trendx_scan_first_column']"/>
            </td>
            <td class="grey-end">
              <xsl:value-of select="$localization[@name='trendx_scan_second_column']"/>
            </td>
          </tr>
          <tr>
            <td class="data1b">
              <xsl:value-of select="$localization[@name='trendx_scan_time']"/>
            </td>
            <td class="data1">
              <!--
              <xsl:call-template name="format_datetime_string">
                <xsl:with-param name="datetime_string" select="//record/@filter_scan_time"/>
              </xsl:call-template>
              -->
              <xsl:value-of select="//record/@filter_scan_time"/>
            </td>
          </tr>
		  <tr>
            <td class="data2b">
              <xsl:value-of select="$localization[@name='trendx_scan_action']"/>
            </td>
            <td class="data2"> 
              <xsl:call-template name="filter_action_string">
                <xsl:with-param name="filter_action_id" select="//record/@filter_action"/>
              </xsl:call-template>
            </td>
          </tr>
		  
		  <!-- attachment filename -->
          <tr>
            <td class="data1b" rowspan="2">
              <xsl:value-of select="$localization[@name='trendx_scan_attachment']"/>
            </td>
            <td class="data1">
              <xsl:value-of select="//record/@file_name"/>
            </td>
          </tr>
		  <tr>
		  <td class="data1">
              <xsl:call-template name="AddFileWhiteList">
                <xsl:with-param name="param-file-sha256" select="//record/@file_sha256"/>
              </xsl:call-template>
            </td>
		  </tr>
		  
          <tr>
            <td class="data2b">
              <xsl:value-of select="$localization[@name='trendx_scan_endpoint']"/>
            </td>
            <td class="data2">
              <xsl:value-of select="//record/@hostname"/>
            </td>
          </tr>
          <tr>
            <td class="data1b">
              <xsl:value-of select="$localization[@name='trendx_scan_found_at']"/>
            </td>
            <td class="data1">
              <xsl:value-of select="//record/@msg_found_at"/>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </xsl:template>

  <xsl:template name="detail-body">
    <!--||Table of Threat Info||-->
	
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
          <tr>
            <td class="tableheader" colspan="2">
              <xsl:value-of select="$localization[@name='trendx_threat_title']"/>
            </td>
          </tr>
          <tr>
            <td class="grey" width="30%">
              <xsl:value-of select="$localization[@name='trendx_threat_first_column']"/>
            </td>
            <td class="grey-end">
              <xsl:value-of select="$localization[@name='trendx_threat_second_column']"/>
            </td>
          </tr>
          <tr>
            <td class="data1b">
              <xsl:value-of select="$localization[@name='trendx_threat_probability']"/>
            </td>
            <td class="data1">
              <xsl:value-of select="//record/@threat_probability"/>%
            </td>
          </tr>
          <tr>
            <td class="data2b">
              <xsl:value-of select="$localization[@name='trendx_threat_type']"/>
            </td>
            <td class="data2"> 
              <xsl:call-template name="threat_type_string">
                <xsl:with-param name="threat_type_name" select="//record/@threat_type"/>
              </xsl:call-template>
            </td>
          </tr>
          <!--
				<tr><td class="data1b">
						<xsl:value-of select="$localization[@name='trendx_threat_identifiers']"/></td>
					<td class="data1"><xsl:value-of select="//record/@threat_identifiers"/>
						</td></tr>
       -->

          <!--
				call StringToArr template to resolve similar_known_threats string, the string gotten from db is : Threat1;Threat2;Threat3 
				after it resolve, the string should be array: [Threat1,Threat2,Threat3] and  get each threat by index
       -->
          <xsl:call-template name="StringToArr">
            <xsl:with-param name="param-field-name"     select="trendx_threat_similar"/>
            <xsl:with-param name="param-field-value"     select="//record/@similar_known_threats"/>
          </xsl:call-template>
          

        </table>
      </td>
    </tr>
  </xsl:template>

  <xsl:template name="filter_action_string" >
    <xsl:param name="filter_action_id"/>
    <xsl:value-of select="$action_description_list[@id=$filter_action_id]"/>
  </xsl:template>
  
   <xsl:template name="threat_type_string" >
    <xsl:param name="threat_type_name"/>
    <xsl:value-of select="$trendx_threat_type_list[@name=$threat_type_name]"/>
  </xsl:template>

  <xsl:template name="AddFileWhiteList">
    <xsl:param name="param-file-sha256"/>

    <a id="addSHA256" class="detaildatabutton">
      <xsl:attribute name="href">
        <xsl:value-of select="$AddFileSHA256_js_function"/>
        <xsl:value-of select="$param-file-sha256"/>
        <xsl:value-of select="$AddFileSHA256_js_function_end"/>
      </xsl:attribute>
      <img id="cmdAddItem_img" src="../images/icon_add_rule.gif" class="vAlignMid">
        <xsl:value-of select="$AddFileSHA256_btn_text"/>
      </img>
    </a>

  </xsl:template>



  <xsl:template name="detail-foot">
  </xsl:template>

  <xsl:template name="GetStringByIndex">
    <xsl:param name="param-Strings"/>
    <xsl:param name="param-Index"/>
    <xsl:param name="param-arrSize"/>

    <xsl:if test="not($param-Index = $param-arrSize)">
	<xsl:variable name="SimilarThreatString" select="trend:getStrFromStringsByIndex(string($param-Strings), floor($param-Index))"/>
      <xsl:choose>	
        <xsl:when test="$param-Index = 0">
          <tr>
            <td rowspan="{$param-arrSize}" class="data2b">
              <xsl:value-of select="$localization[@name='trendx_threat_similar']"/>
            </td>
            <td class="data2">
			
			<!--add the link for similar_known_threats-->
			<a target="_new">
          <xsl:attribute name="href">
            <xsl:value-of select="$virus_encyclopedia_link"/>
            <xsl:value-of select="$SimilarThreatString"/>
          </xsl:attribute>
          <xsl:value-of select="$SimilarThreatString"/>
        </a>
             
            </td>
          </tr>
        </xsl:when>
        <xsl:otherwise>
          <tr>
            <td class="data2">
			
			<!--add the link for similar_known_threats-->
			<a target="_new">
			<xsl:attribute name="href">
            <xsl:value-of select="$virus_encyclopedia_link"/>
            <xsl:value-of select="$SimilarThreatString"/>
			</xsl:attribute>
			<xsl:value-of select="$SimilarThreatString"/>
			</a>
			
            </td>
          </tr>
        </xsl:otherwise>
      </xsl:choose>

      <xsl:call-template name="GetStringByIndex">
        <xsl:with-param name="param-Strings" select="$param-Strings" />
        <xsl:with-param name="param-Index" select="$param-Index + 1" />
        <xsl:with-param name="param-arrSize" select="$param-arrSize" />

      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <!--|| TEMPLATE: StringToArr-->
  <xsl:template name="StringToArr" xmlns:ms="urn:schemas-microsoft-com:xslt">
    <xsl:param name="param-field-name"/>
    <xsl:param name="param-field-value"/>

    <xsl:variable name="arrSize" select="trend:getArraySize(string($param-field-value))"/>
    <xsl:if test="not($arrSize=0)">

      <!-- Due to xslt 1.0 programing limitation, I use a recursion to loop-->
      <xsl:call-template name="GetStringByIndex">
        <xsl:with-param name="param-Strings" select="$param-field-value"/>
        <xsl:with-param name="param-Index">
          <xsl:text>0</xsl:text>
          <!-- default value to 0 -->
        </xsl:with-param>
        <xsl:with-param name="param-arrSize" select="$arrSize - 1"/>  <!-- the string is like "1;2;3;", so the array size should -1 -->
      </xsl:call-template>

    </xsl:if>

  </xsl:template>

  <!--|| DATETIME SCRIPT FUNCTION -->
  <msxsl:script language="JScript" implements-prefix="trend">
    <![CDATA[
		function GetLocaleDateTimeString(datetime_string, part)
		{
     //the time maybe like 2017-05-22 19:20:12:05.000
      var i=datetime_string.indexOf('.');
      if(i!=-1)
	  {
        datetime_string=datetime_string.substring(0,i);
		}
			var oDate = new Date(datetime_string);
			if (part == 'to_datetime')
				return oDate.toLocaleString();
			else if (part == 'to_date')
			{
				var sLocaleDateString = "";
				try
				{
					sLocaleDateString = oDate.toLocaleDateString();
				}
				catch (e)
				{
				}
				return sLocaleDateString;
			}
			else if (part == 'to_time')
			{
				var sLocaleTimeString = "";
				try
				{
					sLocaleTimeString = oDate.toLocaleTimeString();
				}
				catch (e)
				{
				}
				return sLocaleTimeString;
			}
			else
				return "";
		}
		
		//function dbgLog(s)
		//{
		//	var fso = new ActiveXObject("Scripting.FileSystemObject");
		//	var f = fso.OpenTextFile("c:\\jslog.txt", 8, true);
		//	f.WriteLine(s);
		//	f.Close();
		//	fso = null;
		//}
		
		function pad (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		}
			
		function formatDateTime (dt, msk) {
			var mask = msk;
			
			var utc = false;
			if (mask == "")
				return dt;
			
			var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
			timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
			timezoneClip = /[^-+\dA-Z]/g;
			
			// Passing date through Date applies Date.parse, if necessary
			var date = new Date(dt);
			if (isNaN(date)) {
				return dt;
			}
		
			// Allow setting the utc argument via the mask
			if (mask.slice(0, 4) == "UTC:") {
				mask = mask.slice(4);
				utc = true;
			}
			
			var i18n = {
				dayNames: [
					"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
					"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
				],
				monthNames: [
					"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
					"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
				]
			};
		
			var	_ = "get",
				d = date[_ + "Date"](),
				D = date[_ + "Day"](),
				m = date[_ + "Month"](),
				y = date[_ + "FullYear"](),
				H = date[_ + "Hours"](),
				M = date[_ + "Minutes"](),
				s = date[_ + "Seconds"](),
				L = date[_ + "Milliseconds"](),
				o = utc ? 0 : date.getTimezoneOffset(),
				flags = {
					d:    d,
					dd:   pad(d),
					ddd:  i18n.dayNames[D],
					dddd: i18n.dayNames[D + 7],
					M:    m + 1,
					MM:   pad(m + 1),
					MMM:  i18n.monthNames[m],
					MMMM: i18n.monthNames[m + 12],
					yy:   String(y).slice(2),
					yyyy: y,
					h:    H % 12 || 12,
					hh:   pad(H % 12 || 12),
					H:    H,
					HH:   pad(H),
					m:    M,
					mm:   pad(M),
					s:    s,
					ss:   pad(s),
					l:    pad(L, 3),
					L:    pad(L > 99 ? Math.round(L / 10) : L),
					t:    H < 12 ? "a"  : "p",
					tt:   H < 12 ? "am" : "pm",
					T:    H < 12 ? "A"  : "P",
					TT:   H < 12 ? "AM" : "PM",
					Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
					o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
					S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
				};
		
			return mask.replace(token, 
				function ($0) {
					return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
				}
			);
		}
    
    function getStrFromStringsByIndex(strInput, index)
    {
    
		  var vTemp = strInput.split(";"); //the sep is ";"   
      return vTemp[index];
    }
    
    function getArraySize(strInput)
    {
    var vTemp;
    var size;
    if(strInput.length == 0){
	       size = 0;
	    }
	  else{
		     vTemp = strInput.split(";"); //the sep is ";"
         size = vTemp.length;
		   }
       
    return size;
    }
	
	//]]>
  </msxsl:script>

  <xsl:template name="format_datetime_string" xmlns:ms="urn:schemas-microsoft-com:xslt">
    <xsl:param name="datetime_string"/>
    <xsl:variable name="datetime_string_normalize" select="translate($datetime_string, '-', '/')"/>
    <xsl:value-of select="trend:GetLocaleDateTimeString($datetime_string_normalize, 'to_datetime')"/>
  </xsl:template>

</xsl:stylesheet>
