<?xml version="1.0" encoding="BIG5"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" encoding="UTF-8"/>
	<xsl:template match="/">
		<xsl:call-template name="LEVEL_2"/>
	</xsl:template>
	<xsl:template name="LEVEL_2">
		<xsl:for-each select="SAPolicy/file_attributes/file_types/file_type">
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
				<xsl:if test="hidden='true'"><xsl:attribute name="style">display:none;</xsl:attribute></xsl:if> 
				<tr>
					<td width="20">
						<xsl:element name="input">
							<xsl:attribute name="type">checkbox</xsl:attribute>
							<xsl:attribute name="id">chkSpecified</xsl:attribute>
							<xsl:attribute name="name">chkSpecified<xsl:value-of select="@name"/></xsl:attribute>
							<xsl:attribute name="onclick">setUIChecked(this.checked,fmMain.chkSpecified<xsl:value-of select="@name"/>_items);setUIItemsChecked(fmMain.chkSpecifiedType, fmMain.chkSpecified, false);if(typeof setchkFileTypeSpec=='function')setchkFileTypeSpec();</xsl:attribute>
							<xsl:if test="file_subType/@enable='true'">
								<xsl:attribute name="checked">checked</xsl:attribute>
							</xsl:if>
							<xsl:if test="@disabled='true'">
								<xsl:attribute name="disabled">true</xsl:attribute>
							</xsl:if>
						</xsl:element>
					</td>
					<td nowarp="nowarp">
						<xsl:value-of select="@display_name"/>
						<xsl:text disable-output-escaping="yes"> </xsl:text>
						<xsl:element name="span">
							<xsl:attribute name="id">tabSpecified<xsl:value-of select="@name"/></xsl:attribute>
							<xsl:attribute name="onclick">setUIMoreDisplay(this);</xsl:attribute>
							<xsl:attribute name="class">more-out</xsl:attribute>
							<xsl:attribute name="onmouseover">setUIMoreOverOut(this,true);</xsl:attribute>
							<xsl:attribute name="onmouseout">setUIMoreOverOut(this,false);</xsl:attribute>
							<xsl:element name="img">
								<xsl:attribute name="id">tabSpecified<xsl:value-of select="@name"/>_icon</xsl:attribute>					
								<xsl:attribute name="src">images/more_down_out.gif</xsl:attribute>
							</xsl:element>
							<xsl:if test="@disabled='true'">
								<xsl:attribute name="disabled">true</xsl:attribute>
							</xsl:if>	
						</xsl:element>
					</td>
				</tr>
				<xsl:call-template name="LEVEL_3">
					<xsl:with-param name="pos" select="position()-1"/>		
				</xsl:call-template>
			</table>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="LEVEL_3">
		<xsl:param name="pos"/>
		<tr><td width="20"/>
			<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0" id="tabSpecified{@name}_items" style="display:none">
					<xsl:for-each select="file_subType">
						<tr>
							<td nowarp="nowarp">
								<xsl:element name="input">
									<xsl:attribute name="type">checkbox</xsl:attribute>
									<xsl:attribute name="id">chkSpecified<xsl:value-of select="ancestor::file_type/@name"/>_items</xsl:attribute>
									<xsl:attribute name="name">chkSpecified<xsl:value-of select="@name"/></xsl:attribute>
									<xsl:attribute name="onclick">setUIItemsChecked(fmMain.chkSpecified[<xsl:value-of select="$pos"/>], fmMain.chkSpecified<xsl:value-of select="ancestor::file_type/@name"/>_items, false);setUIItemsChecked(fmMain.chkSpecifiedType, fmMain.chkSpecified, false); if(typeof setchkFileTypeSpec=='function')setchkFileTypeSpec();</xsl:attribute>
									<xsl:if test="@enable='true'">
										<xsl:attribute name="checked">checked</xsl:attribute>
									</xsl:if>
									<xsl:if test="@disabled='true'">
										<xsl:attribute name="disabled">true</xsl:attribute>
									</xsl:if>
								</xsl:element>
								<xsl:value-of select="@display_name"/>
							</td>
						</tr>
					</xsl:for-each>
				</table>
			</td>
		</tr>
	</xsl:template>
</xsl:stylesheet>
