<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="yes"/>

<!--|| TEMPLATE : snap scan summary item ||-->
	<xsl:template match="data[@name='report_item_snap_summary']">
		<table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
			<thead>
				<tr>
					<td class="tableheader" colspan="4"><xsl:value-of select="$localization[@name=current()/@name]"/></td>
				</tr>
				<tr>
					<td class="grey"     width="30%"><xsl:value-of select="$localization[@name='activities']"/></td>
					<td class="grey"     width="20%" align="right"><xsl:value-of select="$localization[@name='frequency']"/></td>
					<td class="grey-end" width="25%" align="right"><xsl:value-of select="$localization[@name='percentage']"/></td>
					<td class="grey-end"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td class="data1b"><xsl:value-of select="$localization[@name='snap_total']"/></td>
					<td class="data1b" align="right"><xsl:value-of select="datarow/@total_snap_count"/></td>
					<td class="data1"  align="right"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
					<td class="data1"></td>
				</tr>
				<tr>
					<td class="data2b"><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
					     <xsl:value-of select="$localization[@name='snap_bec']"/></td>
					<td class="data2b" align="right"><xsl:value-of select="datarow/@snap_bec_detected_count"/></td>
					<td class="data2"  align="right">
						<xsl:call-template name="format_percentage">
							<xsl:with-param name="numerator" select="datarow/@snap_bec_detected_count"/>
							<xsl:with-param name="denominator" select="datarow/@total_snap_count"/></xsl:call-template></td>
					<td class="data2"><xsl:value-of select="$localization[@name='of_total_snap']"/></td>
				</tr>
				<tr>
					<td class="data2b"><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
					     <xsl:value-of select="$localization[@name='phish_detected_count']"/></td>
					<td class="data2b" align="right"><xsl:value-of select="datarow/@phish_detected_count"/></td>
					<td class="data2"  align="right">
						<xsl:call-template name="format_percentage">
							<xsl:with-param name="numerator" select="datarow/@phish_detected_count"/>
							<xsl:with-param name="denominator" select="datarow/@total_snap_count"/></xsl:call-template></td>
					<td class="data2"><xsl:value-of select="$localization[@name='of_total_snap']"/></td>
				</tr>
			</tbody>
		</table>
	</xsl:template>
</xsl:stylesheet>
