<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
  <!--|| TEMPLATE : url click protection summary items ||-->
  <xsl:template match="data[@name='report_item_url_click_summary']">
    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
      <thead>
        <tr>
          <td class="tableheader" colspan="4">
            <xsl:value-of select="$localization[@name=current()/@name]"/>
          </td>
        </tr>
        <tr>
          <td class="grey"     width="30%">
            <xsl:value-of select="$localization[@name='activities']"/>
          </td>
          <td class="grey"     width="20%" align="right">
            <xsl:value-of select="$localization[@name='frequency']"/>
          </td>
          <td class="grey-end" width="20%" align="right">
            <xsl:value-of select="$localization[@name='percentage']"/>
          </td>
          <td class="grey-end" width="30%">
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
          </td>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select=".//datarow/@*">
		<xsl:variable name="col-style">
		  <xsl:choose>
			<xsl:when test="position() mod 2 = 1">data1</xsl:when>
			<xsl:otherwise>data2</xsl:otherwise>
		  </xsl:choose>
	    </xsl:variable>
        <tr>
          <td><xsl:attribute name="class"><xsl:value-of select="$col-style"/>b</xsl:attribute>
		    <xsl:if test="name(.)!= 'url_click_count'">
			  <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
			</xsl:if>
            <xsl:value-of select="$localization[@name=name(current())]"/>
          </td>
          <td align="right"><xsl:attribute name="class"><xsl:value-of select="$col-style"/>b</xsl:attribute>
            <xsl:value-of select="."/>
          </td>
          <td align="right"><xsl:attribute name="class"><xsl:value-of select="$col-style"/></xsl:attribute>
		    <xsl:if test="name(.) != 'url_click_count'">
			  <xsl:call-template name="format_percentage">
                <xsl:with-param name="numerator" select="."/>
                <xsl:with-param name="denominator" select="../@url_click_count"/>
              </xsl:call-template>
			</xsl:if>
		  </td>
          <td><xsl:attribute name="class"><xsl:value-of select="$col-style"/></xsl:attribute>
		  	<xsl:if test="name(.) != 'url_click_count'">
              <xsl:value-of select="$localization[@name='of_total_url_click_count']"/>
			</xsl:if>
		  </td>
        </tr>
		</xsl:for-each>
      </tbody>
    </table>
  </xsl:template>
</xsl:stylesheet>
