<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:msxsl="urn:schemas-microsoft-com:xslt"
      xmlns:trend="http://trendmicro.com/smex">
  <xsl:output method="html" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
  <!--<xsl:variable name="localization"      select="document('localization.xml')/strings/group[@name='trendx_detail']//string"/>-->
  <xsl:variable name="snap_report_feature_id"      select="document('snap_report_detail.xml')/strings/group[@name='snap_report_feature_id']//string"/>
  <xsl:variable name="snap_report_feature_all"      select="document('snap_report_detail.xml')/strings/group[@name='snap_report_feature_all']//string"/>
  <xsl:variable name="snap_report_field"      select="document('snap_report_detail.xml')/strings/group[@name='snap_report_field']//string"/>
  <xsl:template match="/">
    <html>
      <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <link href="../css/trend-style-new.css" rel="stylesheet" type="text/css"/>
        <script language="JavaScript" src="../javascripts/trend-ui-new.js"></script>
        <script language="JavaScript" src="../javascripts/OLH_Mapping.js"></script>
        <script language="JavaScript" src="../javascripts/prototype.js"></script>
        <script language="JavaScript" src="../javascripts/localization.js"></script>       
        <title>
          <xsl:value-of select="$snap_report_field[@name='PageTitle']"/>
        </title>
        <style>
          body 			{FONT-SIZE: 10px;COLOR: #000000;FONT-FAMILY: "Verdana", "Arial", "Helvetica", "sans-serif"; margin:0px; padding-top:0px;}
          a:link			{COLOR: #000000;TEXT-DECORATION: underline;}
          a:visited		{COLOR: #000000;TEXT-DECORATION: underline;}
          a:hover			{COLOR: #ff0000;TEXT-DECORATION: none;}
          img				{BORDER: 0px;VERTICAL-ALIGN: middle;}
          td				{FONT-SIZE: 10px;COLOR: #000000;}
          .content-title 	{FONT-WEIGHT: bold;FONT-SIZE: 13px;COLOR: #333333;}
          .tableheader	{BORDER-TOP: #ffffff 1px solid;BORDER-LEFT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;PADDING-LEFT: 5px;FONT-WEIGHT: bold;HEIGHT: 22px;COLOR: #5b593d;BACKGROUND-COLOR: #dddcc5;}
          .border			{BORDER: #666666 1px solid;}
          .grey			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-RIGHT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey-end		{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-BOTTOM: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey2			{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-RIGHT: #ffffff 1px solid;BORDER-BOTTOM: #999999 1px solid;BORDER-TOP: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .grey2-end		{PADDING-RIGHT: 3px;PADDING-LEFT: 3px;PADDING-BOTTOM: 1px;PADDING-TOP: 1px;BORDER-BOTTOM: #999999 1px solid;BORDER-TOP: #999999 1px solid;HEIGHT: 22px;BACKGROUND-COLOR: #d4d4d4;}
          .data1			{PADDING:3px;BACKGROUND-COLOR: #ffffff;}
          .data1b			{PADDING:3px;BACKGROUND-COLOR: #ffffff;BORDER-RIGHT: #cccccc 1px solid;}
          .data2			{PADDING:3px;BACKGROUND-COLOR: #ececdb;}
          .data2b			{PADDING:3px;BACKGROUND-COLOR: #ececdb;BORDER-RIGHT: #cccccc 1px solid;}
        </style>
      </head>

      <body>
        <div align="center">
          <a name="top-of-page"/>
          <xsl:call-template name="detail-banner"/>
          <table width="650" border="0" cellspacing="0" cellpadding="0"  align="center">
            <xsl:call-template name="detail-head"/>
            <!--<tr><td height="30"></td></tr> add a empty row -->
            <xsl:call-template name="detail-body"/>
            <xsl:call-template name="detail-foot"/>
          </table>
        </div>
      </body>
    </html>
  </xsl:template>

  <!--|| TEMPLATE : detail-banner || -->
  <xsl:template name="detail-banner">
    <table width="650" border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td height="44" width="650">
          <img src="../images/new_banner.gif" />
        </td>
      </tr>
    </table>
  </xsl:template>

  <xsl:template name="detail-head">
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td class="content-title" height="25" style="word-break:break-word;">
              <xsl:value-of select="$snap_report_field[@name='report_title']"/>
            </td>
            <td align="right">
              <div id="divToolbar"></div>
            </td>
          </tr>
        </table>
    </td>
      </tr>

    <tr>
      <td height="1" background="../images/dot.gif" style="background-position:center;background-repeat:repeat-x;"></td>
    </tr>
    <tr>
      <td height="10"></td>
    </tr>
    <!--||Table of  header||-->
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">
          <tr>
            <td class="tableheader" colspan="2">
              <xsl:value-of select="$snap_report_field[@name='table_header']"/>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </xsl:template>

  <xsl:template name="replace_one">
    <xsl:param name="param1" />
    <xsl:param name="param1-before" />
    <xsl:param name="param1-after" />
    <xsl:value-of select="concat($param1-before,$param1, $param1-after)"/>
  </xsl:template>

  <xsl:template name="replace_two">
    <xsl:param name="param1" />
    <xsl:param name="param2" />
    <xsl:param name="part1" />
    <xsl:param name="part2" />
    <xsl:param name="part3" />
    <xsl:param name="feature_id" />
    <xsl:choose>
      <xsl:when test="$feature_id='28'">
        <xsl:value-of select="concat($part1,$param2, $part2, $param1, $part3)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="concat($part1,$param1, $part2, $param2, $part3)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="replace_three">
    <xsl:param name="param1" />
    <xsl:param name="param2" />
    <xsl:param name="param3" />
    <xsl:param name="part1" />
    <xsl:param name="part2" />
    <xsl:param name="part3" />
    <xsl:param name="part4" />
    <xsl:param name="feature_id" />
    <xsl:value-of select="concat($part1,$param1, $part2, $param2, $part3, $param3, $part4)"/>
  </xsl:template>

  <xsl:template name="replace_four">
    <xsl:param name="param1" />
    <xsl:param name="param2" />
    <xsl:param name="param3" />
    <xsl:param name="param4" />
    <xsl:param name="part1" />
    <xsl:param name="part2" />
    <xsl:param name="part3" />
    <xsl:param name="part4" />
    <xsl:param name="part5" />
    <xsl:param name="feature_id" />

    <xsl:choose>
      <xsl:when test="$feature_id='6'">
        <xsl:value-of select="concat($part1,$param2, $part2, $param3, $part3, $param4, $part4,$param1, $part5)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="concat($part1,$param1, $part2, $param2, $part3, $param3, $part4,$param4, $part5)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!--|| TEMPLATE : detail-body ||-->

  <xsl:template name="detail-body">
    <tr>
      <td>
        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="border">

          <tr>
            <td class="grey" width="35%">
              <xsl:value-of select="$snap_report_field[@name='column_desc']"/>
            </td>
            <td class="grey-end">
              <xsl:value-of select="$snap_report_field[@name='column_content']"/>
            </td>
          </tr>
          <xsl:for-each select="//REPORTS/FEATURE">
            <xsl:variable name="toggle"	select="boolean(position() mod 2)"/>
            <xsl:variable name="feature_id" select="@id"/>


            <tr>
              <xsl:variable name="islast" select="boolean(position() = last())"/>
              <xsl:variable name="current_value" select="."></xsl:variable>
              <xsl:variable name="col_style">
                <xsl:choose>
                  <xsl:when test="$toggle">data1</xsl:when>
                  <xsl:otherwise>data2</xsl:otherwise>
                </xsl:choose>
                <!--<xsl:if test="position()!=last()">b</xsl:if>-->
              </xsl:variable>
              <td>

                <xsl:variable name="col_style1">
                  <xsl:value-of select="concat($col_style,'b')"/>
                </xsl:variable>

                <xsl:attribute name="class">
                  <xsl:value-of select="$col_style1"/>
                </xsl:attribute>

                <xsl:value-of select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description" />

              </td>
              <td>
                <xsl:attribute name="class">
                  <xsl:value-of select="$col_style"/>
                </xsl:attribute>

                <xsl:variable name="param-num">
                  <xsl:value-of select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Param_Number"/>
                </xsl:variable>


                <xsl:choose>
                  <xsl:when test="$param-num='1'">
                    <xsl:variable name="param1-before" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part1" />
                    <xsl:variable name="param1-after" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part2" />
                    <xsl:variable name="param1" select="./KEYWORD" />
                    <xsl:call-template name="replace_one">
                      <xsl:with-param name="param1"     select="$param1"/>
                      <xsl:with-param name="param1-before"     select="$param1-before"/>
                      <xsl:with-param name="param1-after"   select="$param1-after"/>
                    </xsl:call-template>
                  </xsl:when>

                  <xsl:when test="$param-num='2'">
                    <xsl:variable name="part1" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part1" />
                    <xsl:variable name="part2" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part2" />
                    <xsl:variable name="part3" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part3" />
                    <xsl:variable name="param1" select="./KEYWORD[1]" />
                    <xsl:variable name="param2" select="./KEYWORD[2]" />
                    <xsl:call-template name="replace_two">
                      <xsl:with-param name="param1"     select="$param1"/>
                      <xsl:with-param name="param2"     select="$param2"/>
                      <xsl:with-param name="part1"   select="$part1"/>
                      <xsl:with-param name="part2"   select="$part2"/>
                      <xsl:with-param name="part3"   select="$part3"/>
                      <xsl:with-param name="feature_id"   select="$feature_id"/>
                    </xsl:call-template>
                  </xsl:when>

                  <xsl:when test="$param-num='3'">
                    <xsl:variable name="part1" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part1" />
                    <xsl:variable name="part2" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part2" />
                    <xsl:variable name="part3" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part3" />
                    <xsl:variable name="part4" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part4" />
                    <xsl:variable name="param1" select="./KEYWORD[1]" />
                    <xsl:variable name="param2" select="./KEYWORD[2]" />
                    <xsl:variable name="param3" select="./KEYWORD[3]" />
                    <xsl:call-template name="replace_three">
                      <xsl:with-param name="param1"     select="$param1"/>
                      <xsl:with-param name="param2"     select="$param2"/>
                      <xsl:with-param name="param3"     select="$param3"/>
                      <xsl:with-param name="part1"   select="$part1"/>
                      <xsl:with-param name="part2"   select="$part2"/>
                      <xsl:with-param name="part3"   select="$part3"/>
                      <xsl:with-param name="part4"   select="$part4"/>
                      <xsl:with-param name="feature_id"   select="$feature_id"/>
                    </xsl:call-template>
                  </xsl:when>

                  <xsl:when test="$param-num='4'">
                    <xsl:variable name="part1" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part1" />
                    <xsl:variable name="part2" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part2" />
                    <xsl:variable name="part3" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part3" />
                    <xsl:variable name="part4" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part4" />
                    <xsl:variable name="part5" select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Feature_Description_Part5" />
                    <xsl:variable name="param1" select="./KEYWORD[1]" />
                    <xsl:variable name="param2" select="./KEYWORD[2]" />
                    <xsl:variable name="param3" select="./KEYWORD[3]" />
                    <xsl:variable name="param4" select="./KEYWORD[4]" />
                    <xsl:call-template name="replace_four">
                      <xsl:with-param name="param1"     select="$param1"/>
                      <xsl:with-param name="param2"     select="$param2"/>
                      <xsl:with-param name="param3"     select="$param3"/>
                      <xsl:with-param name="param4"     select="$param4"/>
                      <xsl:with-param name="part1"   select="$part1"/>
                      <xsl:with-param name="part2"   select="$part2"/>
                      <xsl:with-param name="part3"   select="$part3"/>
                      <xsl:with-param name="part4"   select="$part4"/>
                      <xsl:with-param name="part5"   select="$part5"/>
                      <xsl:with-param name="feature_id"   select="$feature_id"/>
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="$snap_report_feature_all[@Feature_ID=$feature_id]/@Detail_Feature_Description"/>
                  </xsl:otherwise>

                </xsl:choose>
              </td>
            </tr>
          </xsl:for-each>
        </table>
      </td>
    </tr>
  </xsl:template>




  <xsl:template name="detail-foot">
  </xsl:template>
</xsl:stylesheet>
