// the page which use this file function should supply displayData function(see function orderBy)

var aryOriginalData = new Array();
var aryDisplayedData = new Array();

var currentOrderTDId = "server_name";
var currentOrderBy = "server_name_asc";

// key: td colum id
// value: sort name prefix
var vSortColumn = 
{
	"server_name":"server_name",
	"security_risk":"virus",
	"virus_malware_uncleanable":"virus_uncleanable",
	"exploits":"expolits",
	"blocked_attachments":"blocked_attachments",
	"prSpam":"spam",
	"prDLP":"data_loss_prevention",
	"prSNAP":"advanced_spam",
	"prURL":"url",
	"prURLRewrite":"urlrewrite",
	"prContentViolation":"content_violations",
	"message_scanned":"message_scanned",
	"unscanable_message":"unscanable_files"
}
	
var vSort = 
{
	"server_name_asc": function(a, b)
	{
		var x = a.vServerName.toLowerCase();
		var y = b.vServerName.toLowerCase();
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"server_name_desc": function(a, b)
	{
		var x = a.vServerName.toLowerCase();
		var y = b.vServerName.toLowerCase();
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"virus_asc":function(a, b)
	{
		var x = parseInt(a.vVirus);
		var y = parseInt(b.vVirus);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"virus_desc":function(a, b)
	{
		var x = parseInt(a.vVirus);
		var y = parseInt(b.vVirus);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"virus_uncleanable_asc":function(a, b)
	{
		var x = parseInt(a.vVirusUncleanable);
		var y = parseInt(b.vVirusUncleanable);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"virus_uncleanable_desc":function(a, b)
	{
		var x = parseInt(a.vVirusUncleanable);
		var y = parseInt(b.vVirusUncleanable);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"exploits_asc":function(a, b)
	{
		var x = parseInt(a.vExploits);
		var y = parseInt(b.vExploits);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"exploits_desc":function(a, b)
	{
		var x = parseInt(a.vExploits);
		var y = parseInt(b.vExploits);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},	
	"blocked_attachments_asc":function(a, b)
	{
		var x = parseInt(a.vBlockedAttachments);
		var y = parseInt(b.vBlockedAttachments);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"blocked_attachments_desc":function(a, b)
	{
		var x = parseInt(a.vBlockedAttachments);
		var y = parseInt(b.vBlockedAttachments);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"spam_asc":function(a, b)
	{
		var x = parseInt(a.vSpam);
		var y = parseInt(b.vSpam);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"spam_desc":function(a, b)
	{
		var x = parseInt(a.vSpam);
		var y = parseInt(b.vSpam);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"advanced_spam_asc":function(a, b)
	{
		var x = parseInt(a.vSNAP);
		var y = parseInt(b.vSNAP);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"advanced_spam_desc":function(a, b)
	{
		var x = parseInt(a.vSNAP);
		var y = parseInt(b.vSNAP);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"data_loss_prevention_asc":function(a, b)
	{
		var x = parseInt(a.vDataLossPrevention);
		var y = parseInt(b.vDataLossPrevention);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"data_loss_prevention_desc":function(a, b)
	{
		var x = parseInt(a.vDataLossPrevention);
		var y = parseInt(b.vDataLossPrevention);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"url_asc":function(a, b)
	{
		var x = parseInt(a.vURL);
		var y = parseInt(b.vURL);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"url_desc":function(a, b)
	{
		var x = parseInt(a.vURL);
		var y = parseInt(b.vURL);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"urlrewrite_asc":function(a, b)
	{
		var x = parseInt(a.vRewritedURL);
		var y = parseInt(b.vRewritedURL);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"urlrewrite_desc":function(a, b)
	{
		var x = parseInt(a.vRewritedURL);
		var y = parseInt(b.vRewritedURL);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"content_violations_asc":function(a, b)
	{
		var x = parseInt(a.vContentViolations);
		var y = parseInt(b.vContentViolations);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"content_violations_desc":function(a, b)
	{
		var x = parseInt(a.vContentViolations);
		var y = parseInt(b.vContentViolations);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"message_scanned_asc":function(a, b)
	{
		var x = parseInt(a.vMessagesScanned);
		var y = parseInt(b.vMessagesScanned);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"message_scanned_desc":function(a, b)
	{
		var x = parseInt(a.vMessagesScanned);
		var y = parseInt(b.vMessagesScanned);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	},
	"unscanable_files_asc":function(a, b)
	{
		var x = parseInt(a.vUnscannableFiles);
		var y = parseInt(b.vUnscannableFiles);
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
	"unscanable_files_desc":function(a, b)
	{
		var x = parseInt(a.vUnscannableFiles);
		var y = parseInt(b.vUnscannableFiles);
		return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	}
};

var orderStatus = {
	"order_unOrdered":0,
	"order_asc":1,
	"order_desc":-1
};

var orderAscImage = "arrow_up.gif";
var orderDescImage = "arrow_down.gif";

function createOrderLink(text, status, tdId)
{	
	var sortColum = vSortColumn[tdId];
	
	var linkOrderBy = sortColum;
	if( status == orderStatus.order_unOrdered)
	{
		// server name asc as default
		// otherwise desc as default
		if(sortColum == vSortColumn.server_name)
			linkOrderBy = sortColum + "_asc";
		else
			linkOrderBy = sortColum + "_desc";
		
		return "<a href='javascript:orderBy(\"" + tdId + "\",\"" + linkOrderBy + "\");'>" + text + "</a>";
	}
	else if(status == orderStatus.order_asc)
	{
		linkOrderBy = sortColum + "_desc";
		return "<a href='javascript:orderBy(\"" + tdId + "\",\"" + linkOrderBy + "\");'>" + text + "</a>" + "<image src=\"images\\" + orderAscImage +"\"/>" ;
	}
	else if(status == orderStatus.order_desc)
	{
		linkOrderBy = sortColum + "_asc";
		return "<a href='javascript:orderBy(\"" + tdId + "\",\"" + linkOrderBy + "\");'>" + text + "</a>" + "<image src=\"images\\" + orderDescImage +"\"/>";
	}
}

function setSortLinkStatus(tdId, status)
{
	var objTD = document.getElementById(tdId);
	//function exit when objTD do not exist .
	if(objTD===null) return;
	var text = objTD.innerText;

	var linkHtml = createOrderLink(text, status, tdId);
	objTD.innerHTML = linkHtml;
}

// should be only asc or desc
function getOrderStatusByOrderName(orderBy)
{
	if(orderBy.indexOf("_desc") > -1)
		return orderStatus.order_desc;
	else
		return orderStatus.order_asc;
}

// the page which use this function should supply displayData function
function orderBy(tdId, orderBy)
{	
	setSortLinkStatus(currentOrderTDId, orderStatus.order_unOrdered);
	
	var currentStatus = getOrderStatusByOrderName(orderBy);
	setSortLinkStatus(tdId, currentStatus);
	currentOrderTDId = tdId;
	currentOrderBy = orderBy;
	
	aryDisplayedData.sort(vSort[orderBy]);
	displayData(aryDisplayedData);
}

function searchByServerName()
{
	inputObj = this;
	var searchString = inputObj.value;
	//trim search string
	searchString = searchString.replace(/(^\s*)|(\s*$)/g, "");

	aryDisplayedData.length = 0;
	var len = aryOriginalData.length;		
	if(searchString == "")
	{
		for(var i=0; i < len; ++i)
		{
			aryDisplayedData.push(aryOriginalData[i]);
		}
		orderBy(currentOrderTDId, currentOrderBy);
		return;
	}		

	searchString = searchString.toLowerCase();


	for(var i=0; i<len; ++i)
	{
		var vServerName = aryOriginalData[i].vServerName;
		if(vServerName.toLowerCase().indexOf(searchString) == 0)
		{
			aryDisplayedData.push(aryOriginalData[i]);
		}
	}
	orderBy(currentOrderTDId, currentOrderBy);
	
	return;
}

function registerSearchInput(inputId)
{
	if(/msie/i.test(navigator.userAgent))    //ie use onpropertychange
	{
		document.getElementById(inputId).onpropertychange=searchByServerName 
	} 
	else 
	{ // firefox use on input
		document.getElementById(inputId).addEventListener("input",searchByServerName,false); 
	} 
}